-------------------------------------------------------------------------------
--
-- AES Decryption Controller 
-- Written for 128-bit AES decryption project
-- Course: CSEE 4840 - Embedded System Design, Spring 2008
-- Authors: Shrivathsa Bhargav (sb2784)
--			Larry Chen (lc2454)
--			Abhinandan Majumdar (am2993)
--			Shiva Ramudit (syr9)
--
-- Last modified: 5-8-2008
-------------------------------------------------------------------------------

library IEEE;

use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

--Controller for AES Decrypto
entity controller is
port (
	clk, en : in std_logic;
	count   : out std_logic_vector(3 downto 0);
	e0,e1,e2,e3,eoc   : out std_logic
	);
end;

architecture controller_arch of controller is
type state_type is (S0, S1, S2);
signal state : state_type := S0;
signal t_count : std_logic_vector(3 downto 0) := "0000";

begin

process (clk) 
begin

if rising_edge(clk) then

	case state is
		
		--Start State
		when S0 => 
					if en = '1' then
						t_count <= t_count + '1';						
						state <= S1;						
					end if;
		--Checking for the loop Condition			
		when S1 => 
					if en = '1' then
						t_count <= t_count + '1';
						if t_count = "1010" then
						t_count <= "0000";					
						state <= S2;
						end if;
					end if;
		--Intialize to start state if en = '0' after final execution			
		when S2 => 
		            t_count <= "0000";
		            if en = '0' then
						state <= S0;
						
					   end if;
					
	end case;
   

end if;

end process;

-- Iteration Count
count <= t_count; 

--Setting the control bits required for AES Datapath
e0 <= '0' when state = S0 and en = '1' else
	  '1' when state = S1 and en = '1' else
	  '1' when state = S2 and en = '1' else
	  '0';
	
e1 <= '0' when state = S0 and en = '1' else
	  '1' when state = S1 and en = '1' else
	  '1' when state = S2 and en = '1' else
	  '1';
	
e2 <= '1' when state = S0 and en = '1' else
      '1' when state = S1 and en = '1' else
	  '0';
	  
e3 <= '1' when state = S1 and en = '1' and t_count = "1010" else
      '0';

--Setting the EOC(End of Computation) signal once AES Decryption is done.	  
eoc <= '1' when state = S2 and en = '1' else
       '0';
	 
end controller_arch;